QGIS Application - Bug report #16626
DBManager fails to load rasters from service-only PostGIS connections
2017-05-26 06:09 PM - Sandro Santilli

Status: Closed

Priority: Normal

Assignee: Sandro Santilli

Category: DB Manager

Affected QGIS version:2.18.9 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 24526
Description

When PostGIS connections are defined by use of the "service" parameter the raster load (mediated by OGR) fails to work.

Other kind of layers (vector, table-only) work fine.

This is with GDAL-2.3.0 (not sure it matters)

The problem reported by GDAL is that you need at least a DBNAME.
The string passed to ogr doesn't look like including a "service" parameter so it's probbaly never sent by DBManager.

Related issues:
Related to QGIS Application - Bug report # 14436: Failure to connect to postg... Closed 2016-03-07

Associated revisions

Revision 93624b08 - 2017-05-30 05:13 PM - Sandro Santilli

Pass "service" parameter to gdal when opening PostGIS Rasters

Closes #16626 for 2.18

Revision d74864bb - 2017-06-02 04:21 PM - Sandro Santilli

Fix typo in URI service extraction (introduced in 93624b08)

Also add a comment about lack of support in GDAL up to 2.2.x for

service specification in datasource uri

Ref #16626

Revision 861cf9ab - 2017-06-02 04:44 PM - Sandro Santilli

Fix typo in URI service extraction (introduced in 93624b08)

Also add a comment about lack of support in GDAL up to 2.2.x for

service specification in datasource uri

Ref #16626
Revision 78¢34238 - 2017-06-02 05:31 PM - Sandro Santilli

For GDAL sake extract a doname from the connection

Works around GDAL limitation reported in:
https://trac.0osgeo.org/gdal/ticket/6910

Ref #16625

Ref #16626

Revision 6f42b784 - 2017-06-02 05:38 PM - Sandro Santilli

For GDAL sake extract a doname from the connection

Works around GDAL limitation reported in:
https://trac.osgeo.org/gdal/ticket/6910

Ref #16625

Closes #16626

Revision 362d4{06 - 2017-06-06 02:56 PM - Sandro Santilli

Add DBManager test for service-only URI

Ref #16626

Also fixes runs with non-standard QGIS_PGTEST_DB env variable set

Revision 3efee437 - 2017-06-06 05:46 PM - Sandro Santilli
Add test for DBManager's PostGIS connector and plugin

Only enabled when ENABLE_PGTEST is set

Includes test for dbname-less URI and service-only URI

(ref #10600 ref #16625 ref #16626)

The test connects to the ‘qgis_test” database, or what the
QGIS_PGTEST_DB variable requests (as per testsfREADME.md)

A raster table is added to the test postgis setup script,

for use by this new test.

History

#1 - 2017-05-26 06:11 PM - Sandro Santilli
- Related to Bug report #14436: Failure to connect to postgres database defined as service in DB manager added

#2 - 2017-05-26 06:30 PM - Sandro Santilli
- Pull Request or Patch supplied changed from No to Yes
https://trac.osgeo.org/gdal/ticket/6910
https://trac.osgeo.org/gdal/ticket/6910

PR for master branch: https://github.com/qgis/QGIS/pull/4639

#3 - 2017-05-30 09:25 AM - Sandro Santilli
- Affected QGIS version changed from 2.18.8 to 2.18.9

PR for 2.18 branch: https://github.com/qgis/QGIS/pull/4647

#4 - 2017-05-30 05:13 PM - Sandro Santilli
- % Done changed from 0 to 100
- Status changed from Open to Closed

Applied in changeset commit:qgis|93624b0865bf19b328fd0e8cc5cc4330bffd8be?2.

#5 - 2017-06-02 04:09 PM - Sandro Santilli

- Status changed from Closed to Reopened

Reopening because it looks like ogr does not recognize "service" anyway, insisting about having a ‘dbname’ value.

#6 - 2017-06-02 04:26 PM - Sandro Santilli

So | guess a fix here would be to pre-connect with psycopg to find out the name of the database and provide it in the URI.

#7 - 2017-06-02 04:37 PM - Sandro Santilli

Upstream ticket to GDAL was filed here: https://trac.0osgeo.org/gdal/ticket/6910

#8 - 2017-06-02 05:37 PM - Sandro Santilli

commit:78¢3423861 implements the fix suggested in #16626-6 for master branch
backport (and overall automated tests) still pending

#9 - 2017-06-02 05:39 PM - Sandro Santilli
- Status changed from Reopened to Closed

Applied in changeset commit:qgis|6f42b784b98580257e584ca6fec57809bdd56bcO0.
